Attribute VB_Name = "DQHelper"
Option Explicit
Public Function SetCommonDQErrors(CommonErrorRC() As String) As Boolean
   'Sets a string array with text for all DQ return codes
   'Indexed by RC
   
   If UBound(CommonErrorRC) < 99 Then
      SetCommonDQErrors = False
      Exit Function
   End If
      
   CommonErrorRC(0) = "Invalid attributes handle: CWBDQ_INVALID_ATTRIBUTE_HANDLE CWBDQ_START"

   CommonErrorRC(1) = "Invalid data handle: " & _
                        "CWBDQ_INVALID_DATA_HANDLE      CWBDQ_START+1"
   
   CommonErrorRC(2) = "Invalid queue handle : " & _
                       "CWBDQ_INVALID_QUEUE_HANDLE     CWBDQ_START+2"
   
   CommonErrorRC(3) = "Invalid data queue read handle            : " & _
                       "CWBDQ_INVALID_READ_HANDLE      CWBDQ_START+3"
   
   CommonErrorRC(4) = "Invalid maximum record length for a data queue: " & _
                       "CWBDQ_INVALID_QUEUE_LENGTH     CWBDQ_START+4"
   
   CommonErrorRC(5) = "Invalid key length                        : " & _
                       "CWBDQ_INVALID_KEY_LENGTH       CWBDQ_START+5"
   
   CommonErrorRC(6) = "Invalid queue order                       : " & _
                       "CWBDQ_INVALID_ORDER            CWBDQ_START+6"
   
   CommonErrorRC(7) = "Invalid queue authority                   : " & _
                       "CWBDQ_INVALID_AUTHORITY        CWBDQ_START+7"
   
   CommonErrorRC(8) = "Queue title (description) is too long or cannot be converted: " & _
                       "CWBDQ_INVALID_QUEUE_TITLE      CWBDQ_START+8"
   
   CommonErrorRC(9) = "Queue name is too long or cannot be converted: " & _
                       "CWBDQ_BAD_QUEUE_NAME           CWBDQ_START+9"
   
   CommonErrorRC(10) = "Library name is too long or cannot be converted  " & _
                       "CWBDQ_BAD_LIBRARY_NAME         CWBDQ_START+10"
   
   CommonErrorRC(11) = "System name is too long or cannot be converted " & _
                       "CWBDQ_BAD_SYSTEM_NAME          CWBDQ_START+11"
   
   CommonErrorRC(12) = "Length of key is not correct for this data queue " & _
                        "or key length is greater than 0 for a LIFO or FIFO data queue " & _
                       "CWBDQ_BAD_KEY_LENGTH           CWBDQ_START+12"
   
   CommonErrorRC(13) = "Length of data is not correct for this data queue.  Either the " & _
                        "data length is zero or it is greater than the maximum allowed " & _
                        "of 31744 bytes.  " & _
                        "CWBDQ_BAD_DATA_LENGTH          CWBDQ_START+13"
   
   CommonErrorRC(14) = "Wait time is not correct                  : " & _
                        "CWBDQ_INVALID_TIME             CWBDQ_START+14"
   
   CommonErrorRC(15) = "Search order is not correct               : " & _
                        "CWBDQ_INVALID_SEARCH           CWBDQ_START+15"
   
   CommonErrorRC(16) = "Returned data was truncated               : " & _
                        "CWBDQ_DATA_TRUNCATED           CWBDQ_START+16"
   
   CommonErrorRC(17) = "Wait time has expired and no data has been returned " & _
                        "CWBDQ_TIMED_OUT                CWBDQ_START+17"
   
   CommonErrorRC(18) = "Command rejected by user exit program     : " & _
                       "CWBDQ_REJECTED_USER_EXIT       CWBDQ_START+18"
   
   CommonErrorRC(19) = "Error in user exit program or invalid number of exit programs " & _
                       "CWBDQ_USER_EXIT_ERROR          CWBDQ_START+19"
   
   CommonErrorRC(20) = "Library not found on system               : " & _
                       "CWBDQ_LIBRARY_NOT_FOUND        CWBDQ_START+20"
   
   CommonErrorRC(21) = "Queue not found on system                 : " & _
                       "CWBDQ_QUEUE_NOT_FOUND          CWBDQ_START+21"
   
   CommonErrorRC(22) = "No authority to library or data queue     : " & _
                       "CWBDQ_NO_AUTHORITY             CWBDQ_START+22"
   
   CommonErrorRC(23) = "Data queue is in an unusable state        : " & _
                       "CWBDQ_DAMAGED_QUEUE            CWBDQ_START+23"
   
   CommonErrorRC(24) = "Data queue already exists                 : " & _
                       "CWBDQ_QUEUE_EXISTS             CWBDQ_START+24"
   
   CommonErrorRC(25) = "Invalid message length - exceeds queue maximum record length " & _
                       "CWBDQ_INVALID_MESSAGE_LENGTH   CWBDQ_START+25"
   
   CommonErrorRC(26) = "Queue destroyed while waiting to read or peek a record " & _
                        "CWBDQ_QUEUE_DESTROYED          CWBDQ_START+26"
   
   CommonErrorRC(27) = "No data was received                      : " & _
                        "CWBDQ_NO_DATA                  CWBDQ_START+27"
   
   CommonErrorRC(28) = "Data cannot be converted for this data queue.  The data queue " & _
                        "can be used but data cannot be converted between ASCII and " & _
                        "EBCDIC.  The convert flag on the data object will be ignored.  " & _
                        "CWBDQ_CANNOT_CONVERT           CWBDQ_START+28"
   
   CommonErrorRC(29) = "Syntax of the data queue name is incorrect.  Queue name must " & _
                        "follow AS/400 object syntax.   First character must be " & _
                        "alphabetic and all following characters alphanumeric  " & _
                        "CWBDQ_QUEUE_SYNTAX             CWBDQ_START+29"
   
   CommonErrorRC(30) = "Syntax of the library name is incorrect.  Library name must " & _
                        "follow AS/400 object syntax.   First character must be " & _
                        "alphabetic and all following characters alphanumeric. " & _
                        "CWBDQ_LIBRARY_SYNTAX           CWBDQ_START+30"
   
   CommonErrorRC(31) = "Address not set.  The data object was not set with with " & _
                        "cwbDQ_SetDataAddr(), so the address cannot be retrieved.  " & _
                        "Use cwbDQ_GetData() instead of cwbDQ_GetDataAddr()." & _
                       "CWBDQ_ADDRESS_NOT_SET     CWBDQ_START+31"
   
   CommonErrorRC(32) = "Host error occurred for which no return is defined.  " & _
                        "See the error handle for the message text. " & _
                        "CWBDQ_HOST_ERROR          CWBDQ_START+32"
   
   CommonErrorRC(99) = "Unexpected error                        : " & _
                        "CWBDQ_UNEXPECTED_ERROR    CWBDQ_START+99"

End Function
